function SoptOverDout = fSoptOverD(SoptOverD, HoverD, Ra)
% Input Variables :     SoptOverD   : Sopt / D
%                       Hover D     : H / D
%                       Ra          : Input Ra values of 300 =< Ra =< 100000                        
SoptOverDout = SoptOverD * (2 + SoptOverD) / (1 + SoptOverD)^(2/3) - 2.75 * (HoverD)^(1/3) * Ra^(-1/4);

