A) 
From the output of [L,U,P] = lu(B)

Matlab chooses to do the row order at :

1 4 3 7 9 5 10 6 8 2

B)

Therefore A, we can see that :

P =

    [1     0     0     0     0     0     0     0     0     0
     0     0     0     0     0     0     0     0     0     1
     0     0     1     0     0     0     0     0     0     0
     0     1     0     0     0     0     0     0     0     0
     0     0     0     0     0     1     0     0     0     0
     0     0     0     0     0     0     0     1     0     0
     0     0     0     1     0     0     0     0     0     0
     0     0     0     0     0     0     0     0     1     0
     0     0     0     0     1     0     0     0     0     0
     0     0     0     0     0     0     1     0     0     0]

Therefore
P1 = 
[    1     0     0     0     0     0     0     0     0      0
     0     1     0     0     0     0     0     0     0      0
     0     0     1     0     0     0     0     0     0      0
     0     0     0     1     0     0     0     0     0      0
     0     0     0     0     1     0     0     0     0      0
     0     0     0     0     0     1     0     0     0      0
     0     0     0     0     0     0     1     0     0      0
     0     0     0     0     0     0     0     1     0      0
     0     0     0     0     0     0     0     0     1      0
     0     0     0     0     0     0     0     0     0      1]
 
P2 =
[    1     0     0     0     0     0     0     0     0     0
     0     0     0     0     0     0     0     0     0     1
     0     0     1     0     0     0     0     0     0     0
     0     1     0     0     0     0     0     0     0     0
     0     0     0     0     0     1     0     0     0     0
     0     0     0     0     0     0     0     1     0     0
     0     0     0     1     0     0     0     0     0     0
     0     0     0     0     0     0     0     0     1     0
     0     0     0     0     1     0     0     0     0     0
     0     0     0     0     0     0     1     0     0     0]
 
P3 = 
[    1     0     0     0     0     0     0     0     0      0
     0     1     0     0     0     0     0     0     0      0
     0     0     1     0     0     0     0     0     0      0
     0     0     0     1     0     0     0     0     0      0
     0     0     0     0     1     0     0     0     0      0
     0     0     0     0     0     1     0     0     0      0
     0     0     0     0     0     0     1     0     0      0
     0     0     0     0     0     0     0     1     0      0
     0     0     0     0     0     0     0     0     1      0
     0     0     0     0     0     0     0     0     0      1]
 
>> [LP,U] = lu(B)

LP =

    1.0000         0         0         0         0         0         0         0         0         0
    0.8284    0.5344    0.9585    1.0000         0         0         0         0         0         0
    0.7321    0.7503    1.0000         0         0         0         0         0         0         0
    0.6667    0.8601    0.8647   -0.6492    0.4265   -0.7585    1.0000         0         0         0
    0.6180    0.9218    0.6946   -0.9262    0.8086   -0.6484    0.5817    0.8769    1.0000         0
    0.5798    0.9581    0.5272   -0.9527    1.0000         0         0         0         0         0
    0.5486    0.9795    0.3731   -0.8224    0.9855    0.6683   -0.1706   -0.6514   -0.4352    1.0000
    0.5224    0.9917    0.2344   -0.5964    0.7911    1.0000         0         0         0         0
    0.5000    0.9979    0.1105   -0.3140    0.4517    0.8034    0.1805    1.0000         0         0
    0.4805    1.0000         0         0         0         0         0         0         0         0


U =

    0.5000    0.4142    0.3660    0.3333    0.3090    0.2899    0.2743    0.2612    0.2500    0.2403
         0    0.0195    0.0284    0.0335    0.0368    0.0389    0.0404    0.0414    0.0422    0.0427
         0         0   -0.0006   -0.0012   -0.0018   -0.0023   -0.0027   -0.0030   -0.0033   -0.0036
         0         0         0    0.0000    0.0000    0.0000    0.0001    0.0001    0.0001    0.0001
         0         0         0         0   -0.0000   -0.0000   -0.0000   -0.0000   -0.0000   -0.0000
         0         0         0         0         0   -0.0000   -0.0000   -0.0000   -0.0000   -0.0000
         0         0         0         0         0         0   -0.0000   -0.0000   -0.0000   -0.0000
         0         0         0         0         0         0         0   -0.0000   -0.0000   -0.0000
         0         0         0         0         0         0         0         0    0.0000    0.0000
         0         0         0         0         0         0         0         0         0    0.0000
    
    
>> A = LP * U

A =

    0.5000    0.4142    0.3660    0.3333    0.3090    0.2899    0.2743    0.2612    0.2500    0.2403
    0.4142    0.3536    0.3178    0.2929    0.2740    0.2588    0.2463    0.2357    0.2265    0.2185
    0.3660    0.3178    0.2887    0.2679    0.2520    0.2391    0.2284    0.2193    0.2113    0.2043
    0.3333    0.2929    0.2679    0.2500    0.2361    0.2247    0.2153    0.2071    0.2000    0.1937
    0.3090    0.2740    0.2520    0.2361    0.2236    0.2134    0.2048    0.1975    0.1910    0.1852
    0.2899    0.2588    0.2391    0.2247    0.2134    0.2041    0.1963    0.1895    0.1835    0.1782
    0.2743    0.2463    0.2284    0.2153    0.2048    0.1963    0.1890    0.1827    0.1771    0.1722
    0.2612    0.2357    0.2193    0.2071    0.1975    0.1895    0.1827    0.1768    0.1716    0.1669
    0.2500    0.2265    0.2113    0.2000    0.1910    0.1835    0.1771    0.1716    0.1667    0.1623
    0.2403    0.2185    0.2043    0.1937    0.1852    0.1782    0.1722    0.1669    0.1623    0.1581 

>> P1

P1 =

     1     0     0     0     0     0     0     0     0     0
     0     0     0     0     0     0     0     0     0     1
     0     0     1     0     0     0     0     0     0     0
     0     1     0     0     0     0     0     0     0     0
     0     0     0     0     0     1     0     0     0     0
     0     0     0     0     0     0     0     1     0     0
     0     0     0     1     0     0     0     0     0     0
     0     0     0     0     0     0     0     0     1     0
     0     0     0     0     1     0     0     0     0     0
     0     0     0     0     0     0     1     0     0     0
     
>> P2

P2 =

     1     0     0     0     0     0     0     0     0     0
     0     1     0     0     0     0     0     0     0     0
     0     0     1     0     0     0     0     0     0     0
     0     0     0     1     0     0     0     0     0     0
     0     0     0     0     1     0     0     0     0     0
     0     0     0     0     0     1     0     0     0     0
     0     0     0     0     0     0     1     0     0     0
     0     0     0     0     0     0     0     1     0     0
     0     0     0     0     0     0     0     0     1     0
     0     0     0     0     0     0     0     0     0     1

>> P3

P3 =

     1     0     0     0     0     0     0     0     0     0
     0     1     0     0     0     0     0     0     0     0
     0     0     1     0     0     0     0     0     0     0
     0     0     0     1     0     0     0     0     0     0
     0     0     0     0     1     0     0     0     0     0
     0     0     0     0     0     1     0     0     0     0
     0     0     0     0     0     0     1     0     0     0
     0     0     0     0     0     0     0     1     0     0
     0     0     0     0     0     0     0     0     1     0
     0     0     0     0     0     0     0     0     0     1
     
>> Linv =

    1.0000         0         0         0         0         0         0         0         0         0
   -0.4805    1.0000         0         0         0         0         0         0         0         0
   -0.3715   -0.7503    1.0000         0         0         0         0         0         0         0
   -0.2155    0.1847   -0.9585    1.0000         0         0         0         0         0         0
   -0.1289   -0.3865   -1.4404    0.9527    1.0000         0         0         0         0         0
    0.0146   -0.3999    0.3336   -0.1573   -0.7911    1.0000         0         0         0         0
   -0.0060   -0.2299   -0.6197    0.1235   -1.0265    0.7585    1.0000         0         0         0
    0.0004   -0.3196    0.0831   -0.0123    0.3692   -0.9403   -0.1805    1.0000         0         0
    0.0002    0.2377    0.0862   -0.0073   -1.0481    1.0317   -0.4235   -0.8769    1.0000         0
    0.0000   -0.0435    0.0213   -0.0015   -0.8476   -0.7024   -0.1313    0.2698    0.4352    1.0000
    
    
>> Linv = inv(L)

Linv =

    1.0000         0         0         0         0         0         0         0         0         0
   -0.4805    1.0000         0         0         0         0         0         0         0         0
   -0.3715   -0.7503    1.0000         0         0         0         0         0         0         0
   -0.2155    0.1847   -0.9585    1.0000         0         0         0         0         0         0
   -0.1289   -0.3865   -1.4404         0    1.0000         0         0         0         0         0
    0.0146   -0.3999    0.3336   0   0    0         0         0         0         0
   -0.0060   -0.2299   -0.6197    0   0    0    1.0000         0         0         0
    0.0004   -0.3196    0.0831   0    0   0   0    1.0000         0         0
    0.0002    0.2377    0.0862   0   0    0   0   0    1.0000         0
    0.0000   -0.0435    0.0213   0   0   0   0    0    0.4352    1.0000

>> L3(1:10,1:3) = Linv(1:10,1:3)

L3 =

    1.0000         0         0         0         0         0         0         0         0         0
   -0.4805    1.0000         0         0         0         0         0         0         0         0
   -0.3715   -0.7503    1.0000         0         0         0         0         0         0         0
   -0.2155    0.1847   -0.9585    1.0000         0         0         0         0         0         0
   -0.1289   -0.3865   -1.4404         0    1.0000         0         0         0         0         0
    0.0146   -0.3999    0.3336         0         0    1.0000         0         0         0         0
   -0.0060   -0.2299   -0.6197         0         0         0    1.0000         0         0         0
    0.0004   -0.3196    0.0831         0         0         0         0    1.0000         0         0
    0.0002    0.2377    0.0862         0         0         0         0         0    1.0000         0
    0.0000   -0.0435    0.0213         0         0         0         0         0         0    1.0000
>> L2(1:10,4:6) = Linv(1:10,4:6)

L2 =

    1.0000         0         0         0         0         0         0         0         0         0
         0    1.0000         0         0         0         0         0         0         0         0
         0         0    1.0000         0         0         0         0         0         0         0
         0         0         0    1.0000         0         0         0         0         0         0
         0         0         0    0.9527    1.0000         0         0         0         0         0
         0         0         0   -0.1573   -0.7911    1.0000         0         0         0         0
         0         0         0    0.1235   -1.0265    0.7585    1.0000         0         0         0
         0         0         0   -0.0123    0.3692   -0.9403         0    1.0000         0         0
         0         0         0   -0.0073   -1.0481    1.0317         0         0    1.0000         0
         0         0         0   -0.0015   -0.8476   -0.7024         0         0         0    1.0000
         
>> L1(1:10,7:9) = Linv(1:10,7:9)

L1 =

    1.0000         0         0         0         0         0         0         0         0         0
         0    1.0000         0         0         0         0         0         0         0         0
         0         0    1.0000         0         0         0         0         0         0         0
         0         0         0    1.0000         0         0         0         0         0         0
         0         0         0         0    1.0000         0         0         0         0         0
         0         0         0         0         0    1.0000         0         0         0         0
         0         0         0         0         0         0    1.0000         0         0         0
         0         0         0         0         0         0   -0.1805    1.0000         0         0
         0         0         0         0         0         0   -0.4235   -0.8769    1.0000         0
         0         0         0         0         0         0   -0.1313    0.2698    0.4352    1.0000
    
>> format long
>> L3 * P3 * L2 * P2 * L1 * P1 * B

ans =

  Columns 1 through 7 

   0.50000000000000   0.41421356237310   0.36602540378444   0.33333333333333   0.30901699437495   0.28989794855664   0.27429188517743
                  0   0.01947584945594   0.02844066543166   0.03354422779337   0.03675737130053   0.03889923314793   0.04037651288246
                  0  -0.00000000000000  -0.00061183691017  -0.00123450063688  -0.00178499263452  -0.00225809757179  -0.00266319007867
  -0.00000000000000   0.00000000000000  -0.00000000000000   0.00000852042944   0.00002167523399   0.00003687502073   0.00005270989477
                  0   0.00000000000000  -0.00000000000000  -0.00000000000000  -0.00000031548630  -0.00000097743382  -0.00000192989480
  -0.00000000000000  -0.00000000000000  -0.00000000000000                  0  -0.00000000000000  -0.00000000252880  -0.00000000924090
  -0.00000000000000  -0.00000000000000  -0.00000000000000   0.00000000000000                  0  -0.00000000000000  -0.00000000004647
  -0.00000000000000                  0                  0  -0.00000000000000   0.00000000000000   0.00000000000000   0.00000000000000
                  0  -0.00000000000000  -0.00000000000000  -0.00000000000000  -0.00000000000000  -0.00000000000000  -0.00000000000000
   0.00000000000000   0.00000000000000   0.00000000000000   0.00000000000000   0.00000000000000   0.00000000000000   0.00000000000000

  Columns 8 through 10 

   0.26120387496374   0.25000000000000   0.24025307335204
   0.04141520024809   0.04215112349236   0.04267080449822
  -0.00301124546933  -0.00331196859308  -0.00357336045232
   0.00006843494926   0.00008366486550   0.00009821040847
  -0.00000310320624  -0.00000443535313  -0.00000587636375
  -0.00000002079085  -0.00000003719487  -0.00000005812883
  -0.00000000019425  -0.00000000048753  -0.00000000095550
  -0.00000000000024  -0.00000000000112  -0.00000000000311
   0.00000000000000   0.00000000000000   0.00000000000002
   0.00000000000000   0.00000000000000   0.00000000000000
         
C) 

 RANK   Matrix rank.
    RANK(A) provides an estimate of the number of linearly
    independent rows or columns of a matrix A.
    RANK(A,tol) is the number of singular values of A
    that are larger than tol.
    RANK(A) uses the default tol = max(size(A)) * norm(A) * eps.

>> tol = max(size(U)) * norm(U) * eps

tol =

    2.347858697756676e-015
    
    

>> format long
>> U

U =

  Columns 1 through 7 

   0.50000000000000   0.41421356237310   0.36602540378444   0.33333333333333   0.30901699437495   0.28989794855664   0.27429188517743
                  0   0.01947584945594   0.02844066543166   0.03354422779337   0.03675737130053   0.03889923314793   0.04037651288246
                  0                  0  -0.00061183691017  -0.00123450063688  -0.00178499263452  -0.00225809757179  -0.00266319007867
                  0                  0                  0   0.00000852042944   0.00002167523399   0.00003687502073   0.00005270989477
                  0                  0                  0                  0  -0.00000031548630  -0.00000097743382  -0.00000192989480
                  0                  0                  0                  0                  0  -0.00000000252880  -0.00000000924090
                  0                  0                  0                  0                  0                  0  -0.00000000004647
                  0                  0                  0                  0                  0                  0                  0
                  0                  0                  0                  0                  0                  0                  0
                  0                  0                  0                  0                  0                  0                  0

  Columns 8 through 10 

   0.26120387496374   0.25000000000000   0.24025307335204
   0.04141520024809   0.04215112349236   0.04267080449822
  -0.00301124546933  -0.00331196859308  -0.00357336045232
   0.00006843494926   0.00008366486550   0.00009821040847
  -0.00000310320624  -0.00000443535313  -0.00000587636375
  -0.00000002079085  -0.00000003719487  -0.00000005812883
  -0.00000000019425  -0.00000000048753  -0.00000000095550
  -0.00000000000024  -0.00000000000112  -0.00000000000311
                  0   0.00000000000000   0.00000000000002
                  0                  0   0.00000000000000
                  
                  
                  
There are only 8 diagonal elements of the matrix U
in the LU factorization of A that are larger than tolerance. So when
calling the rank(U) it return 8 even though it is a 10 x 10 matrix.
