% question 2a
% display the four Lagrange polynomials
% method: treat each Li(X) as a curve fitting
% solve for individual Li(X) where i = 1, 2, 3, 4

x = [0 0. 0.5 1];
y = [-.5 1 .5 .5];

xf = linspace(0,1.4);

L1_x = [1 0 0 0];
L1_coef = polyfit(x, L1_x, 3);
L1_y = polyval(L1_coef, xf);

L2_x = [0 1 0 0];
L2_coef = polyfit(x, L2_x, 3);
L2_y = polyval(L2_coef, xf);

L3_x = [0 0 1 0];
L3_coef = polyfit(x, L3_x, 3);
L3_y = polyval(L3_coef, xf);

L4_x = [0 0 0 1];
L4_coef = polyfit(x, L4_x, 3);
L4_y = polyval(L4_coef, xf);

plot(xf,L1_y,'o',xf,L2_y,'s',xf,L3_y,'d',xf,L4_y,'+');
legend('L1(x)','L2(x)','L3(x)','L4(x)');