% function fSoptOverDeval(H, Ra)
% Input Variables :     H     : H / D
%                       Ra          : Input Ra values of 300 =< Ra =< 100000 

for H = [5:5:20]
    for Ra = [300:50:10000]
        x(1) = 0;
        x(2) = 1;
        k = 2;
        err=1.0e-5;
        while abs(x(k) - x(k-1)) > err
            x(k + 1) = x(k) - fSoptOverD(x(k), H, Ra) * (x(k) - x(k-1)) / (fSoptOverD(x(k), H, Ra) - fSoptOverD(x(k-1), H, Ra));
            k = k + 1;
        end
        axis([300 10000 0 1])
        plot(Ra, x(1:k))
        legend
        hold on
    end
end