function tablez(w,h,b,t0)

% tablez use fzero to find the theta of the picnic table question
%
% Input:    w = width of the table legs
%           h = height of the table legs
%           b = width of the stock used to make the legs
%           t0 = initial guess of theta (in radians)
%
% Output:   Print out the theta

%optimset('Display','iter') keep iterate to see the solution flow 
theta =fzero('legz',t0,optimset('Display','iter'),w,h,b);

fprintf('theta = %6.3f radian\ntheta = %6.1f degree\n', theta, theta*180/pi);