x = [0.0 0.2 0.5 1.0];
y = [-.5 1.0 0.5 0.5];

xf = linspace(min(x), max(x), 200);  % eval interpolant at these dates
p = zeros(size(xf));                 % pre-allocate p for efficiency

for i=1:length(xf)
    p(i) = lagrint(x,y,xf(i));       % interpolate to find p(xf(i))
end
plot(x,y,'o',xf,p,'g-');
xlabel('x'); ylabel('y');